#!/software/bin/perl -wT
#########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-11-27
# Last Modified: $Date: 2008-12-01 14:54:22 +0000 (Mon, 01 Dec 2008) $
# Id:            $Id: archive_from_tarball.pl 3652 2008-12-01 14:54:22Z ajb $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-6.0/scripts/archive_from_tarball.pl $
#

use strict;
use warnings;
use lib qw(lib /software/solexa/lib/site_perl/);
use SangerPaths qw(core ensembl tracking trackingnpg badger);
use npg_qc::api::archive_from_tarball_main;
use npg_qc::api::util;
use LWP::UserAgent;
use Carp;
use English qw{-no_match_vars};

our $VERSION = do { my ($r) = q$LastChangedRevision: 3652 $ =~ /(\d+)/mx; $r; };

$ENV{'PATH'} = join q(:), qw(/bin /usr/bin /usr/local/bin);

main();
0;

sub main {
  print qq{Processing...\n};

  #########
  # overide base uri for npg_qc
  my $uri  = q{http://intweb.sanger.ac.uk/cgi-bin/prodsoft/npg_qc/npg_qc/};
  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });

  ########
  # create main object
  my $api_main = npg_qc::api::archive_from_tarball_main->new({util => $util});

  my ($scratch_dir_root, $id_run, $id_run_pair);
  if (@ARGV) {
    ($scratch_dir_root) =~ /([a-z]+)/xms;
    ($id_run) = $ARGV[1] =~ /(\d+)/xms;
    ($id_run_pair) = $ARGV[0] =~ /(\d+)/xms;
  }

  if (!$id_run) {
    $id_run = q{};
    croak "$ARGV[1] is not a run id\n\nUsage:\n\narchive_from_tarball.pl <top_dir_name> <id_run> (<id_run_pair> if paired)\n\n"
  }

  #######
  # set default expected paths for the GERALD folders with fuzzy matching
  $api_main->set_file_root(q{/$scratch_dir_root/});
  $api_main->set_file_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*_auto/Bustard*/GERALD*/});
  $api_main->set_file_ext(q{*txt});
  $api_main->set_summary_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*_auto/Bustard*/GERALD*/Summary.htm});
  $api_main->set_fastqcheck_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*auto/archive/*fastqcheck});
  $api_main->set_bz_id_run($id_run);
  $api_main->set_bz_id_run_pair($id_run_pair);
  print qq{Created workhorse successfully...\nAttempting to process Bustard output files (this may take a few minutes)...\n} or croak;

  #######
  # run main process_all_bustard file, evaluate and exit
  eval{
    $api_main->process_all_bustard();
  } or do {
    croak $EVAL_ERROR;
  };

  print qq{\nAll Files processed successfully.\n};
}
