#!/software/bin/perl -wT
#########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-06-18
# Last Modified: $Date: 2008-12-01 14:54:22 +0000 (Mon, 01 Dec 2008) $
# Id:            $Id: npg_qc_api.pl 3652 2008-12-01 14:54:22Z ajb $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-6.0/scripts/npg_qc_api.pl $
#

use strict;
use warnings;
use lib qw(/software/solexa/lib/site_perl);
use SangerPaths qw(core ensembl tracking trackingnpg badger);
use npg_qc::api::main;
use npg_qc::api::util;
use LWP::UserAgent;
use Carp;
use English qw{-no_match_vars};

our $VERSION = do { my ($r) = q$LastChangedRevision: 3652 $ =~ /(\d+)/mx; $r; };

$ENV{'PATH'} = join q(:), qw(/bin /usr/bin /usr/local/bin);

main();
0;

sub main {

  print qq{Processing...\n};

  #########
  # overide base uri for npg_qc
  my $uri  = q{http://intweb.sanger.ac.uk/cgi-bin/prodsoft/npg_qc/npg_qc/};
  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });

  ########
  # create main object
  my $api_main = npg_qc::api::main->new({util => $util});

  #######
  # set default expected paths for the GERALD folders with fuzzy matching
  $api_main->set_file_root(q{/});
  $api_main->set_file_dir(q{staging/IL*/outgoing/*run_no/Latest_Summary/});
  $api_main->set_file_ext(q{*txt});
  $api_main->set_summary_dir(q{staging/IL*/outgoing/*run_no/Latest_Summary/Summary.htm});
  $api_main->set_fastqcheck_dir(q{staging/IL*/outgoing/*run_no/Data/*Firecrest*auto/archive/*fastqcheck});

  print qq{Created workhorse successfully...\nAttempting to process Bustard output files (this may take a few minutes)...\n} or croak;

  #######
  # run main process_all_bustard file, evaluate and exit
  eval{
    $api_main->process_all_bustard();
  } or do {
    croak $EVAL_ERROR;
  };

  print qq{\nAll Files processed successfully.\n};
}
