#!/nfs/team117/gq1/dev/bin/perl -wT
##!/software/bin/perl -wT
#########
# Author:        gq1
# Maintainer:    $Author: gq1 $
# Created:       2008-10-24
# Last Modified: $Date: 2008-10-14 09:50:40 +0100 (Tue, 14 Oct 2008) $
# Id:            $Id: npg_qc_api_run_graph.pl 3235 2008-10-14 08:50:40Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/branches/prerelease-3.0/scripts/npg_qc_api_run_graph.pl $
#

use strict;
use warnings;
use lib qw(lib /software/solexa/lib/site_perl/);
use SangerPaths qw(core ensembl tracking trackingnpg badger);
use npg_qc::api::run_caching;
use npg_qc::api::util;
use LWP::UserAgent;
use Carp;
use English qw{-no_match_vars};
use Getopt::Long;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3235 $ =~ /(\d+)/mx; $r; };

$ENV{'PATH'} = join q(:), qw(/bin /usr/bin /usr/local/bin);

main();
0;

sub main {
  print qq{Processing...\n};
  
  my $opts = initialise();

  #########
  # overide base uri for npg_qc
  my $uri  = q{http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/};
  #my $uri  = q{http://intwebdev.sanger.ac.uk/cgi-bin/prodsoft/npg_qc/npg_qc/};

  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });

  my $api_run_caching = npg_qc::api::run_caching->new({
                                       util => $util,
                                       });
  eval{
    if($opts->{id_run}){
      $api_run_caching->instrument_statistics($opts->{id_run}, $opts->{end});
    }else{
      $api_run_caching->instrument_statistics();
    }
    1;
  } or do{
    croak $EVAL_ERROR;
  };

  print "finish process\n";
  return 1;
}
# ----------------------------------------------------------------------
sub initialise {

    my %options = (end=>1, update=>0);

    my $rc = GetOptions(\%options,
                        'id_run:i',
                        'end:i',
                        'update',
                        );
    return \%options;

}
