#########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-07-21
# Last Modified: $Date: 2008-12-01 14:54:22 +0000 (Mon, 01 Dec 2008) $
# Id:            $Id: 10-model-chip_summary.t 3652 2008-12-01 14:54:22Z ajb $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-6.0/t/10-model-chip_summary.t $
#

use strict;
use warnings;
use Test::More tests => 5;
use English qw(-no_match_vars);
use SangerPaths qw(core tracking badger ensembl);
use IO::Scalar;
use lib qw{t};
use t::util;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3652 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::model::chip_summary');

my $util = t::util->new({fixtures =>1});
{
  my $model = npg_qc::model::chip_summary->new({util => $util});
  isa_ok($model, 'npg_qc::model::chip_summary', '$model');
}
{
  my $model;
  eval { $model = npg_qc::model::chip_summary->new({
      util            => $util,
      id_chip_summary => 1,
    });
  };
  is($EVAL_ERROR, q{}, 'model created ok with a id_chip_summary');
}
{
  my $model;
  eval { $model = npg_qc::model::chip_summary->new({
      util            => $util,
      id_run          => 1,
    });
  };
  is($EVAL_ERROR, q{}, 'model created ok with a id_run');
}
{
  my $model;
  eval { $model = npg_qc::model::chip_summary->new({
      util            => $util,
      id_run          => 1,
      id_chip_summary => 1,
    });
  };
  is($EVAL_ERROR, q{}, 'model created ok with a id_run and a id_chip_summary');
}
