#########
# Author:        gq1
# Maintainer:    $Author: ajb $
# Created:       2008-11-12
# Last Modified: $Date: 2008-12-01 14:54:22 +0000 (Mon, 01 Dec 2008) $
# Id:            $Id: 10-model-errors_by_cycle.t 3652 2008-12-01 14:54:22Z ajb $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-6.0/t/10-model-errors_by_cycle.t $
#

use strict;
use warnings;
use Test::More tests => 7;
use English qw(-no_match_vars);
use SangerPaths qw(core tracking badger ensembl);
use IO::Scalar;
use lib qw{t};
use t::util;
use npg_qc::model::errors_by_cycle;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3652 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::model::errors_by_cycle');

my $util = t::util->new({fixtures =>1});
{
  my $model = npg_qc::model::errors_by_cycle->new({util => $util});
  isa_ok($model, 'npg_qc::model::errors_by_cycle', '$model');
}

{
  my $model = npg_qc::model::errors_by_cycle->new({
    util => $util,
    id_run_tile => 20,
  });
  eval { $model->save() };
  like($EVAL_ERROR, qr{Column\ \'cycle\'\ cannot\ be\ null}, 'field cycle in table move_z cannot be null');  
}

{
  my $model = npg_qc::model::errors_by_cycle->new({
    util => $util,
    id_run_tile      => 20,
    cycle            => 4,
    error_percentage => 2,
    blank_percentage => 0.2,
    rescore          => 0,
    
  });
  eval { $model->save() };
  is($EVAL_ERROR, q{}, 'saving data - rescore 0');  
}


{
  my $model = npg_qc::model::errors_by_cycle->new({
    util => $util,
    id_run_tile      => 20,
    cycle            => 4,
    error_percentage => 2,
    blank_percentage => 0.2,
    rescore          => 1,
    
  });
  eval { $model->save() };
  is($EVAL_ERROR, q{}, 'saving data - rescore 1');  
}

{
  my $model = npg_qc::model::errors_by_cycle->new({
    util => $util,
    id_run_tile      => 20,
    cycle            => 4,
    error_percentage => 2,
    blank_percentage => 0.5,
    rescore          => 1,
    
  });
  eval { $model->save() };
  is($EVAL_ERROR, q{}, 'saving data - rescore 1');  
}


{
  my $model = npg_qc::model::errors_by_cycle->new({
    util => $util,
    id_run_tile      => 20,
    cycle            => 4,
    error_percentage => 2,
    blank_percentage => 0.5,
    rescore          => 0,
    
  });
  eval { $model->save() };
  is($EVAL_ERROR, q{}, 'saving data - rescore 0');  
}
