#########
# Author:        gq1
# Maintainer:    $Author: ajb $
# Created:       2008-10-23
# Last Modified: $Date: 2008-12-01 14:54:22 +0000 (Mon, 01 Dec 2008) $
# Id:            $Id: 10-model-instrument_statistics.t 3652 2008-12-01 14:54:22Z ajb $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-6.0/t/10-model-instrument_statistics.t $
#

use strict;
use warnings;
use Test::More  tests => 8;
use English qw(-no_match_vars);
use SangerPaths qw(core tracking badger ensembl);
use IO::Scalar;
use lib qw{t};
use t::util;
use npg_qc::model::instrument_statistics;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3652 $ =~ /(\d+)/mx; $r; };

##
use_ok('npg_qc::model::instrument_statistics');

##
my $util = t::util->new({fixtures =>1});

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util});
  isa_ok($model, 'npg_qc::model::instrument_statistics', '$model');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util});
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'id_run\'\ cannot\ be\ null}, 'id_run can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>5,
                                                        });
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'end\'\ cannot\ be\ null}, 'end can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>10,
                                                         end    =>1,
                                                        });
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'id_run_actual\'\ cannot\ be\ null}, 'id_run_actual can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>10,
                                                         end    =>1,
                                                         id_run_actual =>10,
                                                        });
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'instrument\'\ cannot\ be\ null}, 'instrument can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>10,
                                                         end    =>1,
                                                         id_run_actual =>10,
                                                         instrument  => 'IL8',
                                                        });
  eval{
    $model->save();
    1;
  };
  is($EVAL_ERROR, q{}, 'saving ok');

  eval{
    $model->save();
    1;
  };
  is($EVAL_ERROR, q{}, 're-saving ok');
}
